
syms('F','OK','A','B','N','FLAG','FLAG1','NAME','OUP','E');
 syms('M','FLAG0','C','X','s','D','NTOT');
 syms('xx','yy','zz','xi','yi','zi','Zi');
 syms('IP1','JP1','IP2','JP2','IP3','JP3','IP4','JP4');
 syms('X1','YI','Z1','X2','Y2','Z2','X3','Y3','Z3','X4','Y4','Z4');
 syms('D1','D2','D3','D4','N1','N2','N3','N4');
 TRUE = 1;
 FALSE = 0;
 fprintf(1,'Formula de Interpolacion Spline bicubica en 2D\n');
 OK = FALSE;
 while OK == FALSE 
    fprintf(1,'Elija la forma de entrada de datos:\n');
    fprintf(1,'1.  Generar datos usando una funcion F\n');
    fprintf(1,'2. Entrada desde un fichero de texto\n');
    fprintf(1,'Escriba 1 o 2 \n');
    FLAG = input(' ');
    if FLAG == 1 | FLAG == 2 
        OK = TRUE;
    end
 end
 if FLAG == 1
 OK = FALSE;
 while OK == FALSE
    fprintf(1,'Escriba la longitud de X y de Y en lineas separadas.\n');
    A = input(' ');
    B = input(' ');
    fprintf(1,'Escriba el numero de puntos en X y en Y en lineas separadas.\n');
    N = input(' ');
    M = input(' ');
    if A > 0 & B > 0 & N > 0 & M > 0
       OK = TRUE;
    end
 end
 C = A/(N-1);
 D = B/(M-1);
 [xx,yy] = meshgrid(0:C:A,0:D:B);
 zz = zeros(M,N);
  
    fprintf(1,'Escriba la funcion F(x,y) en terminos de x e y\n');
    fprintf(1,'Por ejemplo: y-x^2+1 \n');
    s = input(' ','s');
    F = inline(char(s),'x','y');
    for J = 1 : N
        for I = 1 : M
            zz(I,J) = F(xx(I,J),yy(I,J));
        end;
    end;
    fprintf(1,'Elija la forma de salida de datos:\n');
    fprintf(1,'1. Pantalla\n');
    fprintf(1,'2. Fichero de texto\n');
    fprintf(1,'Escriba 1 o 2\n');
    FLAG0 = input(' ');
    if FLAG0 == 2 
        fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
        fprintf(1,'Por ejemplo   A:\\OUTPUT.DTA\n');
        NAME = input(' ','s');
        OUP = fopen(NAME,'wt');
    else
        OUP = 1;
    end;
    fprintf(OUP, '%11.5f %11.5f %11.5f %11.5f\n', A,B,N,M);
    for J = 1 : N
        for I = 1 : M
            fprintf(OUP, '%11.5f %11.5f %11.5f\n', xx(I,J),yy(I,J),zz(I,J));
        end;
    end;
    if OUP ~= 1 
        fclose(OUP);
         fprintf(1,'Fichero de salida creado satisfactoriamente \n',NAME);
    end;
 end;
 if FLAG == 2 
    fprintf(1,'Esta creado un fichero de texto con los datos en tres columnas\n');
     fprintf(1,'donde la primera fila contiene la longitud de X, la longitud de Y\n');
     fprintf(1,'y el numero de puntos en X e Y?\n');
    fprintf(1,'Escriba Y o N\n')
    E = input(' ','s');
    if E == 'Y' | E == 'y' 
        fprintf(1,'Escriba el nombre del fichero de la forma - ');
        fprintf(1,'disco:\\nombre.ext\n');
        fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
        NAME = input(' ','s');
        INP = fopen(NAME,'rt');
        A = fscanf(INP, '%f',1);
        B = fscanf(INP, '%f',1);
        N = fscanf(INP, '%f',1);
        M = fscanf(INP, '%f',1);
        C = A/(N-1);
        D = B/(M-1);
        X = zeros(M,N,3);
        [xx,yy] = meshgrid(0:C:A,0:D:B);
        zz = zeros(M,N);
        OK = FALSE;
        while OK == FALSE 
            for J = 1 : N
                for I = 1 : M
                    for K = 1 : 3
                        X(I,J,K) = fscanf(INP, '%f',1);
                    end;
                end;
            end;
            OK = TRUE;
            fclose(INP);
        end
    end;
            
    for J = 1 : N
        for I = 1 : M
            zz(I,J)=X(I,J,3);
        end;
    end;
 end;
  OK = FALSE;
 while OK == FALSE
 fprintf(1,'Introduzca un nuevo numero de puntos para x y para y en lineas separadas\n');
  fprintf(1,'Recuerde que deben ser mayores que los anteriores\n');
 NN = input(' ');
 MM = input(' ');
    if  NN > N & MM > M
        zi = zeros(MM,NN);
        OK = TRUE;
    end;
 end;
 CC = A/(NN-1);
 DD = B/(MM-1);
 [xi,yi] = meshgrid(0:CC:A,0:DD:B);
 zi = interp2(xx,yy,zz,xi,yi,'spline');
 
 

figure(1);
surf(xi,yi,zi);
title('Interpolacion de Spline bicubica 2D');

fprintf(1,'Elija si quiere hacer la interpolacin de Lagrange:\n');
    fprintf(1,'1. No\n');
    fprintf(1,'2. Si\n');
    fprintf(1,'Escriba 1 o 2 \n');
FLAG1 = input(' ');
if FLAG1==1
    fprintf(1,'Fin del programa\n');
end

if FLAG1==2
    Zi = zeros(MM,NN);
    for J = 1 : NN
        for I = 1 : MM
            IP1 = fix(yi(I,J)/D)+1;
            JP1 = fix(xi(I,J)/C)+1;
        if I==MM
            IP1 = fix(yi(I,J)/D);
        end;
        if J==NN
            JP1 = fix(xi(I,J)/C);
        end;
        IP2 = IP1;
        JP2 = JP1+1;
        IP3 = IP1+1;
        JP3 = JP1+1;
        IP4 = IP1+1;
        JP4 = JP1;
        
        X1 = xx(IP1,JP1);
        Y1 = yy(IP1,JP1); 
        X2 = xx(IP3,JP3);
        Y2 = yy(IP3,JP3);
        Z1 = zz(IP1,JP1); 
        Z2 = zz(IP2,JP2);
        Z3 = zz(IP3,JP3);
        Z4 = zz(IP4,JP4);
    
        D1 = ((X2-X1)*(Y2-Y1));
        D2 = -D1;
        D3 = D1;
        D4 = D1;
    
        N1 = (((X2-xi(I,J))*(Y2-yi(I,J)))/D1);
        N2 = (((X1-xi(I,J))*(Y2-yi(I,J)))/D2);
        N3 = (((X1-xi(I,J))*(Y1-yi(I,J)))/D3);
        N4 = (((xi(I,J)-X2)*(Y1-yi(I,J)))/D4);
    
        Zi(I,J) = (N1*Z1+N2*Z2+N3*Z3+N4*Z4);
        
    end;
 end;
figure(2);
surf(xi,yi,Zi);
title('Interpolacion de Lagrange en 2D');
end